const width = 960;
const height = 500;

const margin = {
  top: 10,
  bottom: 35,
  left: 35,
  right: 15
};

const svg = d3.select("svg#bubble");
console.assert(svg.size() == 1);

svg.attr("width", width);
svg.attr("height", height);

const plot = svg.append("g").attr("id", "plot");

// TODO
// plot.append("rect").attr("width", 10).attr("height", 10);

const scales = {
  // TODO 
};

// scales.x.range([0, width - margin.left - margin.right]);
// scales.x.domain([20000, 185000]);
//
// scales.y.range([height - margin.top - margin.bottom, 0]);
// scales.y.domain([-0.5, 10.5]);
//
// scales.r.range([1, 20]).domain([0, 9000]);
//
// scales.fill.domain([-20, 0, 35]);

drawAxis();
drawTitles();
drawColorLegend();
drawCircleLegend();

d3.csv("mrc_table1.csv", convert).then(draw);

function draw(data) {
  console.log("loaded:", data.length, data[0]);

  data = data.filter(row => row.state === "CA");
  console.log("filter:", data.length, data[0]);

  data.sort((a, b) => b.count - a.count);
  console.log("sorted:", data.length, data[0]);

  drawBubble(data);
  drawAverage(data);
  drawLabels(data);
}

function drawLabels(data) {
  const group = plot.append('g').attr('id', 'labels');
  // TODO
}

function drawAverage(data) {
  const group = plot.append('g').attr('id', 'averages');

  const xAverage = d3.mean(data, d=> d.income);
  const yAverage = d3.mean(data, d=> d.mobility);
  console.log('averages:', [xAverage, yAverage]);

  // TODO
}

function drawBubble(data) {
  const group = plot.append('g').attr('id', 'bubbles');
  // TODO
}

// https://beta.observablehq.com/@tmcw/d3-scalesequential-continuous-color-legend-example
function drawColorLegend() {
  const legendWidth = 200;
  const legendHeight = 20;

  const group = svg.append('g').attr('id', 'color-legend');

  // TODO

  // const title = group.append('text')
  //   .attr('class', 'axis-title')
  //   .text('Trend of Parents in Bottom 20%');

  // TODO
}

function drawCircleLegend() {
  const legendWidth = 200;
  const legendHeight = 20;

  const group = svg.append('g').attr('id', 'circle-legend');

  // TODO
}

function drawTitles() {
  // TODO

  // svg.append("circle").attr("cx", xMiddle).attr("cy", yMiddle).attr("r", 5);

  // const xTitle = svg.append('text')
  //   .attr('class', 'axis-title')
  //   .text('Median Parent Household Income');

  // https://developer.mozilla.org/en-US/docs/Web/CSS/transform-function/rotate

  // const yGroup = svg.append('g');
  //
  // const yTitle = yGroup.append('text')
  //   .attr('class', 'axis-title')
  //   .text('Mobility Rate');
}

function drawAxis() {
  const xGroup = svg.append('g').attr('id', 'x-axis').attr('class', 'axis');
  const yGroup = svg.append('g').attr('id', 'y-axis').attr('class', 'axis');

  const xAxis = d3.axisBottom(scales.x);
  const yAxis = d3.axisLeft(scales.y);

  // https://github.com/d3/d3-format#locale_formatPrefix
  // TODO
}

function convert(row) {
  let keep = {}

  keep.name = row.name;
  keep.state = row.state;

  keep.count = parseInt(row.count);
  keep.mobility = parseFloat(row.mr_kq5_pq1);
  keep.income = parseFloat(row.par_median);
  keep.trend = parseFloat(row.trend_bottom40);

  switch(row.name.toLowerCase()) {
    case 'university of san francisco':
      keep.name = 'USF';
      keep.label = true;
      break;

    case 'california state university, los angeles':
      keep.name = 'CalState LA';
      keep.label = true;
      break;

    case 'harvey mudd college':
      keep.name = 'Harvey Mudd';
      keep.label = true;
      break;

    case 'san francisco community college district':
      keep.name = 'SF Community Colleges';
      keep.label = true;
      break;

    case 'san francisco state university':
      keep.name = 'SF State';
      keep.label = true;
      break;

    case 'sonoma state university':
      keep.name = 'Sonoma State';
      keep.label = true;
      break;

    case 'stanford university':
      keep.name = 'Stanford';
      keep.label = true;
      break;

    case 'university of california, los angeles':
      keep.name = 'UCLA';
      keep.label = true;
      break;

    default:
      keep.label = false;
  }

  return keep;
}

function midpoint(range) {
  return range[0] + (range[1] - range[0]) / 2.0;
}

function translate(x, y) {
  return 'translate(' + String(x) + ',' + String(y) + ')';
}
